#include <stdio.h>


#include <stdio.h>

#include <assert.h>
#include <stdio.h>
#include <stdbool.h>
#include <stdio.h>
#include <sel4/sel4.h>
#include <sel4/arch/constants.h>
#include <platsupport/plat/pit.h>
#include <platsupport/arch/tsc.h>
#include <utils/math.h>
#include <platsupport/plat/pit.h>
#include <platsupport/timer.h>
#include <sel4platsupport/timer.h>

#include <Timer.h>

#include <Timer.h>



pstimer_t *timer_drv = NULL;



static uint64_t tsc_frequency = 0;

static int pit_port_in(void *cookie, uint32_t port, int io_size, uint32_t *result) {
   seL4_IA32_IOPort_In8_t reply;
   if (io_size != 1) {
      return -1;
   }

   switch(port) {
      case 0x43:
         *result = pit_command_in8(port);
         return 0;
      case 0x40:
         *result = pit_channel0_in8(port);
         return 0;
      default:
         return -1;
   }
}

static int pit_port_out(void *cookie, uint32_t port, int io_size, uint32_t val) {
   if (io_size != 1) {
      return -1;
   }

   switch(port) {
      case 0x43:
         pit_command_out8(port, val);
         return 0;
      case 0x40:
         pit_channel0_out8(port, val);
         return 0;
      default:
         return -1;
   }
}


static uint64_t current_time_ns() {
       return muldivu64(rdtsc_pure(), NS_IN_S, tsc_frequency);
}

static uint64_t current_time_ms() {
       return muldivu64(rdtsc_pure(), 1000, tsc_frequency);
}


void irq_callback(void *_ UNUSED)
{



timer_handle_irq(timer_drv, 0); 


uint64_t ms = current_time_ms();

if ( ( ms % 1000) == 0)
{
	Hello1_Thr_activator_emit();
}
if ( ( ms % 2000) == 0)
{
	Hello2_Thr_activator_emit();
}

    irq_reg_callback(irq_callback, NULL);
   }





#define TIMER_FREQUENCY 500


void post_init ()
{
   timer_lock();
   ps_io_port_ops_t ops;
   ops.io_port_in_fn = pit_port_in;
   ops.io_port_out_fn = pit_port_out;

   timer_drv = pit_get_timer(&ops);

   tsc_frequency = tsc_calculate_frequency(timer_drv);

   irq_reg_callback(irq_callback, NULL);


   timer_start (timer_drv);
   timer_periodic (timer_drv, (NS_IN_S / 10) /TIMER_FREQUENCY);

//   timer_oneshot_relative(timer_drv, period);

   timer_unlock();
}
